TicketTab = "General";

-- 1d2h3m4s to number in seconds
function GMGenie.timeStrToSeconds(timeStr)
    local days = string.match(timeStr, "([0-9]*)d");
    if not days then
        days = 0;
    end
    local hours = string.match(timeStr, "([0-9]*)h");
    if not hours then
        hours = 0;
    end
    local minutes = string.match(timeStr, "([0-9]*)m");
    if not minutes then
        minutes = 0;
    end
    local seconds = string.match(timeStr, "([0-9]*)s");
    if not seconds then
        seconds = 0;
    end
    return (((((tonumber(days)*24)+tonumber(hours))*60)+tonumber(minutes))*60)+tonumber(seconds);
end

-- Read from chat
local ORIG_ChatFrame_MessageEventHandler = ChatFrame_MessageEventHandler;
function ChatFrame_MessageEventHandler(...)
    ticketobjectthingy, event = ...; -- sorry, I was too lazy to think of a better name =P
	
	local ActionTaken = false;
    
    -- development code to analize chat messages
    --GMGenie.showGMMessage(event);
    -- local excapedarg = string.gsub(arg1, "%|", "%%");
    -- GMGenie.showGMMessage(excapedarg);
    --GMGenie.showGMMessage(event);
	
    -- check for system messages of interest
	if (event == "CHAT_MSG_SYSTEM") then
        -- Showing list of open tickets whose creator is online.
        if string.find(arg1, "Showing list of open tickets") then
            Chronos.scheduleByName('ticketreupdate', 0.5, GMTickets.update);
            ActionTaken = true;
        end
        -- ticket list or reading ticket
        local ticketId, name, createStr, lastModifiedStr, rest = string.match(arg1, "^%|cffaaffaaTicket%|r:%|cffaaccff%s([0-9]+).%|r%s%|cff00ff00Created%sby%|r:%|cff00ccff%s(.+)%|r%s%|cff00ff00Created%|r:%|cff00ccff%s([a-zA-Z0-9%s]+)%sago%|r%s%|cff00ff00Last%schange%|r:%|cff00ccff%s([a-zA-Z0-9%s]+)%sago%|r%s(.*)$");
        
        if ticketId and name and createStr and lastModifiedStr then
            ticketId = tonumber(ticketId);
            local createStamp = GMGenie.timeStrToSeconds(createStr);
            local lastModifiedStamp = GMGenie.timeStrToSeconds(lastModifiedStr);
            GMTickets.listTicket(ticketId, name, createStr, createStamp, lastModifiedStr, lastModifiedStamp);
            
            local assignedTo = string.match(rest, "%|cff00ff00Assigned%sto%|r:%|cff00ccff%s([a-zA-Z]+)%|r%s");
            if assignedTo then
                GMTickets.setAssigned(ticketId, assignedTo);
            end
            local message = string.match(rest, "%|cff00ff00Ticket%sMessage%|r:%s%[(.-)%]%|r");
            local ticketCorrect = true;
            if message then
                ticketCorrect = GMTickets.readTicket(ticketId, message);
            else
                local message = string.match(rest, "%|cff00ff00Ticket%sMessage%|r:%s%[(.*)");
                if message then
                    ticketCorrect = GMTickets.readTicket(ticketId, message);
                    if ticketCorrect then
                        GMTickets.messageOpen = true;
                    end
                end
            end
            
            local comment = string.match(rest, "%|cff00ff00GM%sComment%|r:%s%[(.*)%]%|r");
            if comment then
                GMTickets.setComment(ticketId, message);
            end
            if ticketCorrect then
                ActionTaken = true;
            end
        elseif GMTickets.messageOpen then
            ActionTaken = true;
            local message, rest = string.match(arg1, "(.-)%]%|r(.*)");
            if message then
                GMTickets.messageOpen = false;
                GMTickets.addLine(message);
            else
                if string.find(arg1, "%]%|r") then
                    rest = string.match(arg1, "%]%|r(.*)");
                    GMTickets.messageOpen = false;
                else
                    GMTickets.addLine(arg1);
                end
            end
            
            if rest then
                local comment = string.match(rest, "%|cff00ff00GM%sComment%|r:%s%[(.*)%]%|r");
                if comment then
                    GMTickets.setComment(ticketId, message);
                end
            end
        else
            -- Ticket edited
            local name, ticketId = string.match(arg1, "^%|cff00ff00Character%|r%|cffff00ff%s([a-zA-Z]+)%s%|r%|cff00ff00edited%shis/her%sticket:%|r%|cffff00ff%s([0-9]+).%|r$");
            if name and ticketId then
                if GMTickets.isOpen() then
                    GMTickets.refresh();
                end
                ActionTaken = true;
            end
            -- Ticket abandoned
            local name, ticketId = string.match(arg1, "^%|cff00ff00Character%|r%|cffff00ff%s([a-zA-Z]+)%s%|r%|cff00ff00abandoned%sticket%sentry:%|r%|cffff00ff%s([0-9]+).%|r$");
            if name and ticketId then
                if GMTickets.isOpen() then
                    GMTickets.refresh();
                end
                ActionTaken = true;
            end
            -- New Ticket
            local name, ticketId = string.match(arg1, "^%|cff00ff00New%sticket%sfrom%|r%|cffff00ff%s([a-zA-Z]+).%|r%s%|cff00ff00Ticket%sentry:%|r%|cffff00ff%s([0-9]+).%|r$");
            if name and ticketId then
                if GMTickets.isOpen() then
                    GMTickets.refresh();
                end
                ActionTaken = true;
            end
        end
		
        -- read coords from chat
        GMSpawns_WaitingForGPS = true;
		if GMSpawns_WaitingForGPS then
            local map = string.match(arg1, "^Map:%s([0-9]+)%s");
            local x, y, z, orientation = string.match(arg1, "^X:%s([0-9%.%-]+)%sY:%s([0-9%.%-]+)%sZ:%s([0-9%.%-]+)%sOrientation:%s([0-9%.%-]+)$");
            if map then
                GMGenie.showGMMessage(map);
                ActionTaken = true;
            elseif x and y and z and orientation then
                GMGenie.showGMMessage(x.." "..y.." "..z.." "..orientation);
                ActionTaken = true;
            end
		end
        
        if GMSpy.waitingForPin1 then
            if string.find(arg1, "Player not found!") then
                GMSpy.waitingForPin1 = false;
            else
                local offline, name1, name2, guid, account, accountId, email, gmLevel, ip, login, latency = string.match(arg1, "Player(.*) %|cffffffff%|Hplayer:(.*)%|h%[(.*)%]%|h%|r %(guid: (.*)%) Account: (.*) %(id: (.*)%) Email: (.*) GMLevel: (.*) Last IP: (.*) Last login: (.*) Latency: (.*)");
                if name1 then
                    GMSpy.processPin1(offline, name1, guid, account, accountId, email, gmLevel, ip, login, latency);
                    ActionTaken = true;
                end
            end
        end
        if GMSpy.waitingForPin2 then
            local race, class, playedTime, level, money = string.match(arg1, "Race: (.*) Class: (.*) Played time: (.*) Level: (.*) Money: (.*)");
            if race then
                GMSpy.processPin2(race, class, playedTime, level, money);
                ActionTaken = true;
            end
        end
        if GMSpy.waitingForPin3 then
            local map, area = string.match(arg1, "Map: (.*), Area: (.*)");
            if map then
                area2, zone, phase = string.match(arg1, "(.*), Zone: (.*), Phase: (.*)");
                if area2 then
                    GMSpy.processPin3(map, area2, zone, phase);
                else
                    GMSpy.processPin3(map, area, "", "");
                end
                ActionTaken = true;
            end
        end
        --if GMSpy.WaitingForWho then
        --    local name1, name2, junk, location = string.match(arg1, "%|Hplayer:(.*)%|h%[(.*)%]%|h: Level (.*) %- (.*)");
        --    if junk then
        --        local guild = string.match(junk, "<(.*)>");
        --        if not guild then
        --            guild = "";
        --        end
        --        GMGenie.showGMMessage(name1.." + "..name2.." + "..guild.." + "..location);
        --    end
        --end
    end
	
    -- if nothing was done, just display the message
	if not ActionTaken then
		ORIG_ChatFrame_MessageEventHandler(...);
    end
end