function GMGenie.Macros.Mail.optionsOnLoad()
    panel = getglobal("GMMacros_Mail_OptionsWindow");
	panel.name = "Mail Macros";
	panel.parent = "GM Genie";
	
	InterfaceOptions_AddCategory(panel);
	
	getglobal(panel:GetName().."_Title"):SetText("Mail Macros");
	getglobal(panel:GetName().."_SubText"):SetText("Here you add and update mail macros, which will be available from the ticket interface and the player context menus.");
    GMMacros_Mail_OptionsWindow_Info_Text:SetText("Note: every newline in the mail macro will be a separate mail. It is not possible to have newlines within one mail.\nNote: If the text in the box turns red that means one of the lines (messages) has become too long and might get cut off when sending a mail.\n\nTip: use NAME (in full caps) to use the players' name in the mail text.");
    
    getglobal("GMMacros_Mail_OptionsWindow_Macro_Frame_Text"):SetScript("OnTextChanged", GMGenie.Macros.Mail.updateMacroText);
end

function GMGenie.Macros.Mail.updateMacroText()
    ScrollingEdit_OnTextChanged(getglobal("GMMacros_Mail_OptionsWindow_Macro_Frame_Text"), getglobal("GMMacros_Mail_OptionsWindow_Macro_Frame"));
    GMGenie.Macros.Mail.checkMacroLength();
end

function GMGenie.Macros.Mail.checkMacroLength()
    local macro = GMMacros_Mail_OptionsWindow_Macro_Frame_Text:GetText();
    local macro = string.gsub(macro, "NAME", "abcdefghijkl");
    local lines = {strsplit("\n",macro)};
    
    local maxlength = 226 - string.len(GMMacros_Mail_OptionsWindow_Subject:GetText());
    if #lines > 1 then
        maxlength = maxlength - 4;
    end
    for index,line in pairs(lines) do
        if string.len(line) > maxlength then
            GMMacros_Mail_OptionsWindow_Macro_Frame_Text:SetTextColor(255, 0, 0);
        else
            GMMacros_Mail_OptionsWindow_Macro_Frame_Text:SetTextColor(255, 255, 255);
        end
    end
end

GMGenie.Macros.Mail.currentEditing = nil;

function GMGenie.Macros.Mail.loadOptionsDropdown()
    local MailTemp = GMGenie.pairsByKeys2(GMGenie_SavedVars.mail);
    for index,name in pairs(MailTemp) do
        info = UIDropDownMenu_CreateInfo();
        info.text = name;
        info.value = name;
        info.func = GMGenie.Macros.Mail.edit;
        info.owner = this:GetParent();
        UIDropDownMenu_AddButton(info);
    end
end

function GMGenie.Macros.Mail.test()
    if GMGenie.Macros.Mail.currentEditing then
        GMGenie.Macros.Mail.run(UnitName("player"), GMGenie.Macros.Mail.currentEditing);
    end
end

function GMGenie.Macros.Mail.edit()
	GMGenie.Macros.Mail.currentEditing = this.value;
	GMMacros_Mail_OptionsWindow_Name:SetText(this.value);
    GMMacros_Mail_OptionsWindow_Subject:SetText(GMGenie_SavedVars.mail[this.value]["subject"]);
	GMMacros_Mail_OptionsWindow_Macro_Frame_Text:SetText(GMGenie_SavedVars.mail[this.value]["macro"]);
	GMMacros_Mail_OptionsWindow_Save:SetText("Save");
	GMMacros_Mail_OptionsWindow_Delete:Enable();
end

function GMGenie.Macros.Mail.save()
	local name = GMMacros_Mail_OptionsWindow_Name:GetText();
    local subject = GMMacros_Mail_OptionsWindow_Subject:GetText();
	local macro = GMMacros_Mail_OptionsWindow_Macro_Frame_Text:GetText();
	
	if name and macro and subject and name ~= "" then
		GMGenie_SavedVars.mail[name] = {macro=macro, subject=subject};
		
		if GMGenie.Macros.Mail.currentEditing then
			if (name ~= GMGenie.Macros.Mail.currentEditing) then
				GMGenie_SavedVars.mail[GMGenie.Macros.Mail.currentEditing] = nil;
				GMGenie.Macros.Mail.currentEditing = name;
			end
		else
			GMGenie.Macros.Mail.currentEditing = name;
			GMMacros_Mail_OptionsWindow_Save:SetText("Save");
			GMMacros_Mail_OptionsWindow_Delete:Enable();
		end
	end
	GMGenie.Macros.Mail.addToUnitMenu();
end

function GMGenie.Macros.Mail.delete()
	local name = GMMacros_Mail_OptionsWindow_Name:GetText();
	
	if name and name ~= "" then
		GMGenie_SavedVars.mail[name] = nil;
		GMGenie.Macros.Mail.cleanForm();
	end
	GMGenie.Macros.Mail.addToUnitMenu();
end

function GMGenie.Macros.Mail.cleanForm()
	GMGenie.Macros.Mail.currentEditing = nil;
	GMMacros_Mail_OptionsWindow_Name:SetText("");
	GMMacros_Mail_OptionsWindow_Subject:SetText("");
	GMMacros_Mail_OptionsWindow_Macro_Frame_Text:SetText("");
	GMMacros_Mail_OptionsWindow_Save:SetText("Add");
	GMMacros_Mail_OptionsWindow_Delete:Disable();
end

function GMGenie.Macros.Mail.showOptions()
	InterfaceOptionsFrame_OpenToCategory("Mail Macros");
end